# Staking rates

## What is this endpoint for?

Returns time-series staking metrics for a specified blockchain protocol. The endpoint covers protocol-level data including validator counts, and yield metrics.

### Endpoint

{% code overflow="wrap" %}

```http
https://us.market-api.kaiko.io/v2/data/staking.v1/protocols/{protocol}
```

{% endcode %}

### Parameters

<table><thead><tr><th>Parameter</th><th width="104">Required</th><th width="318">Description</th><th>Example</th></tr></thead><tbody><tr><td><code>protocol</code></td><td>Yes</td><td>The desired protocol code.<br><br>If not specified, the endpoint will return the list of all protocol codes and methodologies.</td><td><code>solana</code></td></tr><tr><td><code>methodology</code></td><td>No</td><td>The desired metodology code.</td><td><code>epoch_aggregate_v1</code></td></tr><tr><td><code>start_time</code></td><td>No</td><td>Starting time in ISO 8601 (inclusive)</td><td><a data-footnote-ref href="#user-content-fn-1"><code>2023-01-25T00:00:00.00</code></a></td></tr><tr><td><code>end_time</code></td><td>No</td><td>Ending time in ISO 8601 (exclusive)</td><td><a data-footnote-ref href="#user-content-fn-1"><code>2023-01-25T00:00:00.00</code></a></td></tr><tr><td><code>start_date</code></td><td>No</td><td>Starting date in YYYYMMDD (inclusive).</td><td><code>20250101</code></td></tr><tr><td><code>end_sate</code></td><td>No</td><td>Ending date in YYYYMMDD (exclusive).</td><td><code>20250102</code></td></tr><tr><td><code>page_size</code></td><td>No</td><td><p>See <a data-mention href="/pages/mP3amLsYqKTsrRBoblxX">/pages/mP3amLsYqKTsrRBoblxX</a><br><br>Minimum: <code>1</code><br>Maximum: <code>1000</code></p><p>Default: <code>1000</code></p></td><td><code>100</code></td></tr><tr><td><code>sort</code></td><td>No</td><td>If <code>asc</code>, sort time-series in ascending. If desc, sort time-series in descending.<br><br>Default: <code>desc</code></td><td><code>asc</code></td></tr></tbody></table>

### Fields

<table><thead><tr><th width="137">Field</th><th width="228">Description</th><th>Example</th></tr></thead><tbody><tr><td><code>date</code></td><td>Date at which the interval begins.</td><td><code>2026-04-21</code></td></tr><tr><td><code>protocol</code></td><td>Protocol code.</td><td><code>solana</code></td></tr><tr><td><code>apr</code></td><td>Daily APR</td><td><code>4.758636</code></td></tr><tr><td><code>validators</code></td><td>Number of validators</td><td><code>777</code></td></tr><tr><td><code>methodology</code></td><td>The methodology used to compute the APR</td><td><code>epoch_aggregate_v1</code></td></tr></tbody></table>

### Request examples

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" %}

```url
curl --compressed -H 'Accept: application/json' -H 'X-Api-Key: <client-api-key>' \
'https://us.market-api.kaiko.io/v2/data/staking.v1/protocols/solana?start_date=20261001'
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code overflow="wrap" %}

```python
import http.client
import json

# Enter your Kaiko API Key
api_key = "KAIKO_API_KEY"
api_host = "us.market-api.kaiko.io"
api_base_endpoint = "/v2/data/staking.v1/protocols/solana"
# Start of mandatory parameter configuration
mandatory_params = {

}
# End of mandatory parameter configuration
# Start of optional parameter configuration
optional_params = {
    'start_date':'20251001',
    'page_size':100,
    'sort':'desc',
    'methodology':'epoch_aggregate_v1'
}
# End of optional parameter configuration
conn = http.client.HTTPSConnection(api_host)
headers = {
    "X-Api-Key": api_key,
    "Accept": "application/json"
}

all_params = {**mandatory_params, **optional_params}

url_params = []
for param, value in all_params.items():
    url_params.append(f"{param}={value}")
url_params = '&'.join(url_params)

endpoint_with_params = f"{api_base_endpoint}?{url_params}"

# Pagination for next pages
all_data = []
next_url = endpoint_with_params
while next_url:
    conn.request("GET", next_url, headers=headers)
    response = conn.getresponse()
    data = json.loads(response.read().decode("utf-8"))
    all_data.extend(data.get("data", []))
    print(f"Fetched {len(data.get('data', []))} datapoints. Total: {len(all_data)}")
    next_url = data.get("next_url", "").replace("https://us.market-api.kaiko.io", "")
    if not next_url:
        break
conn.close()
print(f" datapoints fetched: {(all_data)}")
```

{% endcode %}
{% endtab %}
{% endtabs %}

### Response example

{% code overflow="wrap" %}

```json
{
    "query":
    {
        "start_date": "20260101",
        "end_date": "20260422",
        "start_time": "2026-01-01T00:00:00Z",
        "end_time": "2026-04-22T00:00:00Z",
        "sort": "descending",
        "page_size": "10",
        "methodology": "epoch_aggregate_v1"
    },
    "time": "2026-04-22T14:46:38.274392363Z",
    "timestamp": 1776869198,
    "data":
    [
        {
            "date": "2026-04-21",
            "protocol": "solana",
            "apr": 4.758636113435191,
            "validators": 777,
            "methodology": "epoch_aggregate_v1"
        },
        /** Results **/
    ],
    "continuation_token": "xxx",
    "next_url": "https://eu.market-api.kaiko.io/v2/data/staking.v1/protocols/solana?continuation_token=xxx"
}

```

{% endcode %}

[^1]:


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kaiko.com/rest-api/monitoring-solutions/kaiko-market-explorer/staking-rates.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
